﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="default.aspx.cs" Inherits="FineUI.Examples._default" %>

<!DOCTYPE html>
<html>
<head runat="server">
    <title>FineUI 在线示例 - 基于 ExtJS 的专业 ASP.NET 控件库</title>
    <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
    <meta name="Title" content="基于 ExtJS 的专业 ASP.NET 控件库，拥有原生的 AJAX 支持和华丽的UI效果 (ExtJS based ASP.NET Controls with native AJAX Support and rich UI effects)" />
    <meta name="Description" content="FineUI 的使命是创建 No JavaScript，No CSS，No UpdatePanel，No ViewState，No WebServices 的网站应用程序" />
    <meta name="Keywords" content="extjs,ext,asp.net,control,asp.net 2.0,ajax,web2.0" />
    <link href="css/default.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <form id="form1" runat="server">
        <x:PageManager ID="PageManager1" AutoSizePanelID="RegionPanel1" runat="server"></x:PageManager>
        <x:RegionPanel ID="RegionPanel1" ShowBorder="false" runat="server">
            <Regions>
                <x:Region ID="Region1" Margins="0 0 0 0" ShowBorder="false" Height="50px" ShowHeader="false"
                    Position="Top" Layout="Fit" runat="server">
                    <Items>
                        <x:ContentPanel ShowBorder="false" CssClass="jumbotron" ShowHeader="false" ID="ContentPanel1"
                            runat="server">
                            <div class="title">
                                <a href="http://fineui.com/" title="FineUI首页" class="logo">
                                    <img src="./images/logo/logo2.gif" alt="FineUI Logo" /></a>
                                <a href="./default.aspx">FineUI在线示例</a>
                            </div>
                            <div class="config">
                                <x:Button ID="Button2" EnablePostBack="false" Icon="Cog" Text="设置" runat="server">
                                    <Menu ID="Menu1" runat="server">
                                        <x:MenuButton ID="btnExpandAll" IconUrl="~/images/expand-all.gif" Text="展开菜单" EnablePostBack="false"
                                            runat="server">
                                        </x:MenuButton>
                                        <x:MenuButton ID="btnCollapseAll" IconUrl="~/images/collapse-all.gif" Text="折叠菜单"
                                            EnablePostBack="false" runat="server">
                                        </x:MenuButton>
                                        <x:MenuSeparator ID="MenuSeparator1" runat="server">
                                        </x:MenuSeparator>
                                        <x:MenuButton EnablePostBack="false" Text="菜单样式" ID="MenuStyle" runat="server">
                                            <Menu ID="Menu3" runat="server">
                                                <x:MenuCheckBox Text="树菜单" ID="MenuStyleTree" Checked="true" GroupName="MenuStyle"
                                                    AutoPostBack="true" OnCheckedChanged="MenuStyle_CheckedChanged" runat="server">
                                                </x:MenuCheckBox>
                                                <x:MenuCheckBox Text="手风琴+树菜单" ID="MenuStyleAccordion" GroupName="MenuStyle" AutoPostBack="true"
                                                    OnCheckedChanged="MenuStyle_CheckedChanged" runat="server">
                                                </x:MenuCheckBox>
                                            </Menu>
                                        </x:MenuButton>
                                        <x:MenuButton EnablePostBack="false" Text="语言" ID="MenuLang" runat="server">
                                            <Menu ID="Menu2" runat="server">
                                                <x:MenuCheckBox Text="简体中文" ID="MenuLangZHCN" Checked="true" GroupName="MenuLang"
                                                    AutoPostBack="true" OnCheckedChanged="MenuLang_CheckedChanged" runat="server">
                                                </x:MenuCheckBox>
                                                <x:MenuCheckBox Text="繁體中文" ID="MenuLangZHTW" GroupName="MenuLang" AutoPostBack="true"
                                                    OnCheckedChanged="MenuLang_CheckedChanged" runat="server">
                                                </x:MenuCheckBox>
                                                <x:MenuCheckBox Text="English" ID="MenuLangEN" GroupName="MenuLang" AutoPostBack="true"
                                                    OnCheckedChanged="MenuLang_CheckedChanged" runat="server">
                                                </x:MenuCheckBox>
                                            </Menu>
                                        </x:MenuButton>
                                        <x:MenuButton ID="MenuTheme" EnablePostBack="false" Text="主题" runat="server">
                                            <Menu ID="Menu4" runat="server">
                                                <x:MenuCheckBox Text="Neptune" ID="MenuThemeNeptune" Checked="true" GroupName="MenuTheme"
                                                    AutoPostBack="true" OnCheckedChanged="MenuTheme_CheckedChanged" runat="server">
                                                </x:MenuCheckBox>
                                                <x:MenuCheckBox Text="Blue" ID="MenuThemeBlue" GroupName="MenuTheme"
                                                    AutoPostBack="true" OnCheckedChanged="MenuTheme_CheckedChanged" runat="server">
                                                </x:MenuCheckBox>
                                                <x:MenuCheckBox Text="Gray" ID="MenuThemeGray" GroupName="MenuTheme" AutoPostBack="true"
                                                    OnCheckedChanged="MenuTheme_CheckedChanged" runat="server">
                                                </x:MenuCheckBox>
                                                <x:MenuCheckBox Text="Access" ID="MenuThemeAccess" GroupName="MenuTheme" AutoPostBack="true"
                                                    OnCheckedChanged="MenuTheme_CheckedChanged" runat="server">
                                                </x:MenuCheckBox>
                                            </Menu>
                                        </x:MenuButton>
                                        <x:MenuSeparator ID="MenuSeparator2" runat="server">
                                        </x:MenuSeparator>
                                        <x:MenuHyperLink runat="server" Text="转到英文示例" NavigateUrl="http://fineui.com/demo_en/" Target="_blank"></x:MenuHyperLink>
                                    </Menu>
                                </x:Button>
                            </div>
                        </x:ContentPanel>
                    </Items>
                </x:Region>
                <x:Region ID="Region2" Split="true" Width="200px" ShowHeader="true" Title="示例菜单"
                    EnableCollapse="true" Layout="Fit" Position="Left" runat="server">
                </x:Region>
                <x:Region ID="mainRegion" ShowHeader="false" Layout="Fit" Margins="0 0 0 0" Position="Center"
                    runat="server">
                    <Items>
                        <x:TabStrip ID="mainTabStrip" EnableTabCloseMenu="true" EnableFrame="false" ShowBorder="false" runat="server">
                            <Tabs>
                                <x:Tab Title="首页" Layout="Fit" Icon="House" CssClass="maincontent" runat="server">
                                    <Toolbars>
                                        <x:Toolbar runat="server">
                                            <Items>
                                                <x:ToolbarFill ID="ToolbarFill2" runat="server">
                                                </x:ToolbarFill>
                                                <x:Button ID="btnGotoOpenSourceSite" Icon="DiskDownload" Text="下载全部示例" OnClientClick="window.open('http://fineui.codeplex.com/', '_blank');"
                                                    EnablePostBack="false" runat="server">
                                                </x:Button>
                                                <x:ToolbarSeparator ID="ToolbarSeparator1" runat="server">
                                                </x:ToolbarSeparator>
                                                <x:Button Icon="PageGo" Text="官网首页" EnablePostBack="false" OnClientClick="window.open('http://fineui.com/', '_blank');"
                                                    runat="server">
                                                </x:Button>
                                                <x:ToolbarSeparator ID="ToolbarSeparator2" runat="server">
                                                </x:ToolbarSeparator>
                                                <x:Button ID="Button1" Icon="PageGo" Text="论坛交流" OnClientClick="window.open('http://fineui.com/bbs/', '_blank');"
                                                    EnablePostBack="false" runat="server">
                                                </x:Button>
                                            </Items>
                                        </x:Toolbar>
                                    </Toolbars>
                                    <Items>
                                        <x:ContentPanel ShowBorder="false" BodyPadding="10px" ShowHeader="false" AutoScroll="true"
                                            runat="server">
                                            <h2>关于FineUI</h2>
                                            基于 ExtJS 的专业 ASP.NET 控件库。
                                        
                                            <br />
                                            <h2>FineUI的使命</h2>
                                            创建 No JavaScript，No CSS，No UpdatePanel，No ViewState，No WebServices 的网站应用程序。
                                        
                                            <br />
                                            <h2>支持的浏览器</h2>
                                            IE 7.0+、Firefox 3.6+、Chrome 3.0+、Opera 10.5+、Safari 3.0+
                                        
                                            <br />
                                            <h2>授权协议</h2>
                                            Apache License v2.0（ExtJS 库在 <a target="_blank" href="http://www.sencha.com/license">GPL v3</a> 协议下发布）
                                            
                                            <br />
                                            <h2>相关链接</h2>
                                            首页：<a target="_blank" style="font-weight: bold;" href="http://fineui.com/">http://fineui.com/</a>
                                            <br />
                                            论坛：<a target="_blank" href="http://fineui.com/bbs/">http://fineui.com/bbs/</a>
                                            <br />
                                            示例：<a target="_blank" href="http://fineui.com/demo/">http://fineui.com/demo/</a>
                                            <br />
                                            文档：<a target="_blank" href="http://fineui.com/doc/">http://fineui.com/doc/</a>
                                            <br />
                                            下载：<a target="_blank" href="http://fineui.codeplex.com/">http://fineui.codeplex.com/</a>
                                            <br />
                                            <br />
                                            <br />
                                            注：FineUI 不再内置 ExtJS 库，请手工添加 ExtJS 库：<a target="_blank" href="http://fineui.com/bbs/forum.php?mod=viewthread&tid=3218">http://fineui.com/bbs/forum.php?mod=viewthread&tid=3218</a>

                                        </x:ContentPanel>
                                    </Items>
                                </x:Tab>
                            </Tabs>
                        </x:TabStrip>
                    </Items>
                </x:Region>
            </Regions>
        </x:RegionPanel>
        <x:Window ID="windowSourceCode" Icon="PageWhiteCode" Title="源代码" Hidden="true" EnableIFrame="true"
            runat="server" IsModal="true" Width="950px" Height="550px" EnableClose="true"
            EnableMaximize="true" EnableResize="true">
        </x:Window>
        <asp:XmlDataSource ID="XmlDataSource1" runat="server" DataFile="~/common/menu.xml"></asp:XmlDataSource>
    </form>
    <img src="images/logo/logo3.png" alt="FineUI 图标" id="logo" />
    <script src="./js/default.js" type="text/javascript"></script>
</body>
</html>
